相交链表

题目描述

编写一个程序,找到两个单链表相交的起始节点。

如下面的两个链表:

在节点 c1 开始相交。

示例 1:

1
2
3
4
输入:intersectVal = 8, listA = [4,1,8,4,5], listB = [5,0,1,8,4,5], skipA = 2, skipB = 3
输出:Reference of the node with value = 8
输入解释:相交节点的值为 8 (注意,如果两个链表相交则不能为 0)。从各自的表头开始算起,链表 A 为 [4,1,8,4,5],链表 B 为
[5,0,1,8,4,5]。在 A 中,相交节点前有 2 个节点;在 B 中,相交节点前有 3 个节点。

示例 2:

1
2
3
4
输入:intersectVal = 2, listA = [0,9,1,2,4], listB = [3,2,4], skipA = 3, skipB = 1
输出:Reference of the node with value = 2
输入解释:相交节点的值为 2 (注意,如果两个链表相交则不能为 0)。从各自的表头开始算起,链表 A 为 [0,9,1,2,4],链表 B 为
[3,2,4]。在 A 中,相交节点前有 3 个节点;在 B 中,相交节点前有 1 个节点。

示例 3:

1
2
3
4
5
输入:intersectVal = 0, listA = [2,6,4], listB = [1,5], skipA = 3, skipB = 2
输出:null
输入解释:从各自的表头开始算起,链表 A 为 [2,6,4],链表 B 为 [1,5]。由于这两个链表不相交,所以 intersectVal 必须为 0,而
skipA 和 skipB 可以是任意值。
解释:这两个链表不相交,因此返回 null。

注意:

  • 如果两个链表没有交点,返回 null.
  • 在返回结果后,两个链表仍须保持原有的结构。
  • 可假定整个链表结构中没有循环。
  • 程序尽量满足 $O(n) $时间复杂度,且仅用 $O(1) $内存。

题目链接

Leetcode

题目解答

解法一

暴力法,从链表 A 出发,把每个节点和链表 B 中的每个节点都比较一下,如果两个节点相等,则两链表相交,且相等的节点就是起始交点。

时间复杂度:$O(mn)$ 空间复杂度:$O(1)$

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
/**
* Definition for singly-linked list.
* public class ListNode {
* int val;
* ListNode next;
* ListNode(int x) {
* val = x;
* next = null;
* }
* }
*/
public class Solution {
public ListNode getIntersectionNode(ListNode headA, ListNode headB) {
ListNode pA = headA, pB = headB;
while (pA != null) {
while (pB != null) {
if (pA == pB) {
return pA;
}
pB = pB.next;
}
pA = pA.next;
pB = headB;
}
return null;
}
}

执行用时:789 ms, 在所有 Java 提交中击败了5.01%的用户
内存消耗:41 MB, 在所有 Java 提交中击败了91.03%的用户

解法二

哈希表,我们可以先遍历链表 A 中的所有元素,用Set存起来,然后遍历链表 B 中的每一个节点,如果节点在 Set 中,那么这个节点就是两个链表的起始交点。借助哈希表可以降低时间复杂度,但空间复杂度却增加了,这就是典型的空间换时间。

时间复杂度:$O(m + n)$ 空间复杂度:$O(m)$ 或 $O(n)$

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
public class Solution {
public ListNode getIntersectionNode(ListNode headA, ListNode headB) {
ListNode current = headA;
Set<ListNode> set = new HashSet<>();
while (current != null) {
set.add(current);
current = current.next;
}
current = headB;
while (current != null) {
if (set.contains(current)) {
return current;
}
current = current.next;
}
return null;
}
}

执行用时:8 ms, 在所有 Java 提交中击败了17.73%的用户
内存消耗:42.4 MB, 在所有 Java 提交中击败了5.08%的用户

解法三

双指针,如图我们把 a1-a2 的距离记为 a,把 b1-b3 的距离记为 b,把 c1-c3 的距离记为 c。现在初始化两个指针 pApB 分别指向链表 A、B,同时出发向后遍历,当链表 A 遍历到链表尾的时候把指针 pA 指向链表 B,同理当链表 B 遍历到链表尾的时候把指针 pB 指向链表 A。当两个指针相遇时,也就是到节点 c1 的位置,pA 走过的距离为 a + c + bpB 走过的距离为 b + c + a,很明显 pApB 走过的距离是相等的,此时 pA 指向的节点就是链表的起始交点。如果两个链表不相交,pApB 走过的距离同样相等为 a + b,当两个指针相遇时,分别指向链表 B、A 的表尾。

时间复杂度:$O(m + n)$ 空间复杂度:$O(1)$

1
2
3
4
5
6
7
8
9
10
11
12
13
public class Solution {
public ListNode getIntersectionNode(ListNode headA, ListNode headB) {
ListNode pA = headA, pB = headB;
if (pA == null || pB == null) {
return null;
}
while (pA != pB) {
pA = (pA == null) ? headB : pA.next;
pB = (pB == null) ? headA : pB.next;
}
return pA;
}
}

执行用时:1 ms, 在所有 Java 提交中击败了100.00%的用户
内存消耗:41.1 MB, 在所有 Java 提交中击败了83.04%的用户

-------------本文结束 感谢您的阅读-------------

文章对您有帮助,可以打赏一杯咖啡,鼓励我继续创作!